﻿using System;
using System.Collections.Generic;
using System.Text;

namespace $rootnamespace$.HojasCalculo.Excel
{
    public class GeneradorExcel : IGenerador, IDisposable
    {
        private ExcelApplication excel;
        private bool mostrarExcelAlTerminar;
        private string nombre;

        public GeneradorExcel(bool p_mostrarExcelAlTerminar, string p_nombre)
        {
            this.mostrarExcelAlTerminar = p_mostrarExcelAlTerminar;
            this.nombre = p_nombre;

            this.excel = new ExcelApplication();

            this.excel.ScreenUpdating = false;
        }

        public void Generar(Libro p_libro, PorCadaHoja p_porCadaHoja)
        {
            var v_numeroHoja = 1;

            var v_numeroHojasPorDefecto = this.excel.SheetsInNewWorkbook;
            this.excel.SheetsInNewWorkbook = Math.Max(p_libro.Hojas.Length, 1);
            try
            {
                using (var v_workbooks = excel.Workbooks)
                {
                    using (var v_workbook = v_workbooks.Add())
                    {
                        using (var calculation = new ExcelCalculation(excel, XlCalculation.xlManual))
                        {
                            using (var v_worksheets = v_workbook.Worksheets)
                            {
                                foreach (var v_hoja in p_libro.Hojas)
                                {
                                    p_porCadaHoja(v_hoja, new ProgresoGenerador(v_numeroHoja, p_libro.Hojas.Length));

                                    using (var v_worksheet = v_worksheets.Count >= v_numeroHoja ? v_worksheets[v_numeroHoja] : v_worksheets.Add())
                                    {
                                        using (var v_worksheetAnterior = v_worksheets[v_numeroHoja])
                                        {
                                            if (v_worksheetAnterior.Index != v_worksheet.Index)
                                                v_worksheet.Move(null, v_worksheetAnterior);
                                        }
                                        var v_nombreHoja = string.Format("{0}", v_hoja.Nombre);
                                        v_worksheet.Name = v_nombreHoja;

                                        ComposicionExcel.Componer(this.excel, v_worksheet, v_hoja.Celdas, v_hoja.FuentePredeterminada);

                                        v_numeroHoja++;
                                    }
                                }
                            }
                        }
                        if (!string.IsNullOrEmpty(this.nombre))
                            v_workbook.SaveAs(this.nombre);

                        this.nombre = v_workbook.FullName;
                    }
                }
            }
            finally
            {
                this.excel.SheetsInNewWorkbook = v_numeroHojasPorDefecto;
            }
        }

        public string Nombre { get { return this.nombre; } }

        public void Dispose()
        {
            if (!this.mostrarExcelAlTerminar)
                this.excel.Quit();
            this.excel.Dispose();
        }

        public void Mostrar()
        {
            this.excel.ScreenUpdating = true;
            if (this.mostrarExcelAlTerminar)
                this.excel.Visible = true;
            else
                this.excel.Quit();
        }
    }
}
